#ifndef _JDISP_STRINGUTILS_JSH
#define _JDISP_STRINGUTILS_JSH

OOP_CLASS(StringUtils) = function() {};

OOP_METHOD(StringUtils, formatTuple) = function ()
{
  var i;
  var lp = new PROJECT_PREFIX.text.ListPrinter('(', ',', ')');
  // Note that arguments is a local variable and that it is not an array.
  for (i=0; i<arguments.length; i++)
    lp.append(arguments[i]);
  return lp.toString();
};


OOP_METHOD(StringUtils, formatPoint) = function (point)
{
  if (IS_NON_NULL_OBJECT(point)) {
    return this.formatTuple(point.x, point.y);
  } else {
    return "(invalid-point)";
  }
};

OOP_METHOD(StringUtils, formatDimension) = function (size)
{
  if (IS_NON_NULL_OBJECT(size)) {
    return this.formatTuple(size.width, size.height);
  } else {
    return "(invalid-dimension)";
  }
};

OOP_METHOD(StringUtils, camelize) = function (str)
{
  var out = str;
  if (/-/.exec(str)) {
    var ns = str.split('-');
    out = '';
    for (i=0; i<ns.length; i++) {
      if (/^([a-zA-Z])(.*)$/.exec(ns[i])) {
        out += RegExp.$1.toUpperCase() + RegExp.$2;
      }
    }
  }
  return out;
};

#endif /* _JDISP_STRINGUTILS_JSH */
