#ifndef _JDISP_GUI_FLOATING_JSH
#define _JDISP_GUI_FLOATING_JSH

OOP_CLASS(Floating) = function()
{
  this.nodes = [];

  var me = this;
  var f = function () {
    me.adjustComponents();
  };
  PROJECT_PREFIX.domUtils.setScrollHandler(f);
  PROJECT_PREFIX.domUtils.setResizeHandler(f);
  f();
};
OOP_FIELD(Floating, nodes) = null;

OOP_METHOD(Floating, add) = function (node)
{
  var n = PROJECT_PREFIX.domUtils.getNode(node);
  if (IS_NON_NULL_OBJECT(n)) {
    this.nodes.push(n);
    this.adjustComponent(n);
  }
};
OOP_METHOD(Floating, remove) = function (node)
{
  var n = PROJECT_PREFIX.domUtils.getNode(node);

  for (var i in this.nodes) {
    if (n === this.nodes[i]) {
      delete this.nodes[i];
    }
  }
};

OOP_METHOD(Floating, adjustComponents) = function ()
{
  for (var i in this.nodes) {
    var n = this.nodes[i];
    this.adjustComponent(n);
  }
};

OOP_METHOD(Floating, adjustComponent) = function (node)
{
  var util = PROJECT_PREFIX.domUtils;
  var n = util.getNode(node);
  if (!IS_NON_NULL_OBJECT(n)) return;
  n.style.position = 'absolute';
  var es  = util.getElementSize(n);
  var pos = util.getScrollPosition();
  var cs  = util.getClientSize();
  var ss  = util.getScrollSize();
  var x = cs.width  + pos.x - n.offsetWidth;
  var y = cs.height + pos.y - n.offsetHeight;
  LOG_DEBUG
    ( 'adjustComponent: '
    + ' es=' + PROJECT_PREFIX.stringUtils.formatDimension(es)
    + ' es=' + PROJECT_PREFIX.global.dumpVar(es)
    + ',pos=' + PROJECT_PREFIX.stringUtils.formatPoint(pos)
    + ',cs(b)=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getClientSizeByBody())
    + ',cs(de)=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getClientSizeByDocument())
    + ',cs=' + PROJECT_PREFIX.stringUtils.formatDimension(cs)
    + ',ss(b)=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getScrollSizeByBody())
    + ',ss(de)=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getScrollSizeByDocument())
    + ',ss=' + PROJECT_PREFIX.stringUtils.formatDimension(ss)
    + ',in=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getInnerSize())
    + ',out=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getOuterSize())
    + ',avail=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getAvailableSize())
    + ',screen=' + PROJECT_PREFIX.stringUtils.formatDimension(util.getScreenSize())
    + ',new=' + PROJECT_PREFIX.stringUtils.formatPoint({x:x,y:y})
    );
  util.setElementPosition(n, x, y);
};

#endif /* _JDISP_GUI_FLOATING_JSH */
