#ifndef _JDISP_GUI_MOUSEMOTION_JS
#define _JDISP_GUI_MOUSEMOTION_JS

OOP_CLASS(MouseMotion) = function(targetNode)
{
  var me = this;
  this.targetNode = PROJECT_PREFIX.domUtils.getNode(targetNode);
  var s = this.targetNode.style;
  if (IS_NON_NULL_OBJECT(s)) {
    // Fix the position attribute in order to make the layerX/Y fields have
    // correct values in Firefox and Chrome.
    if (s.position === 'static') {
      s.position = 'relative';
    }
  }
  this.handlers = [];
  var handler = function (ev) {
    var u = PROJECT_PREFIX.domUtils;
    var ee = u.getEventObject(ev);
    var src = u.getEventSource(ee);
    var pos = u.getEventPagePosition(ee);
    var off = u.getEventOffset(ee);
    me._handleEvent(ee, src, pos, off);
  };
  //PROJECT_PREFIX.domUtils.addEventListener(this.targetNode, 'mousemove', handler, false);
  this.targetNode.onmousemove = handler;
};

OOP_FIELD(MouseMotion, targetNode) = null;
OOP_FIELD(MouseMotion, handlers) = null;

OOP_METHOD(MouseMotion, _handleEvent) = function (ee, src, pos, off)
{
  for (var i in this.handlers) {
    var handler = this.handlers[i];
    if (IS_FUNCTION(handler)) {
      handler(ee, src, pos, off, this);
    }
  }
};

OOP_METHOD(MouseMotion, addMouseMotionHandler) = function (handler)
{
  this.handlers.push(handler);
};

OOP_METHOD(MouseMotion, removeMotionHandler) = function (handler)
{
  var list = new Array();
  var i;
  for (i in this.handlers) {
    if (this.handlers[i] === handler) {
      list.push(i);
    }
  }
  for (i in list) {
    delete this.handlers[i];
  }
  return (list.length > 0);
};

#endif /* _JDISP_GUI_MOUSEMOTION_JS */
