#ifndef _JDISP_GUI_PEN_JSH
#define _JDISP_GUI_PEN_JSH

OOP_CLASS(Pen) = function()
{
  this.state = OOP_STATIC_FIELD(Pen, STATE_UP);
};

OOP_STATIC_FIELD(Pen, STATE_UP)  = 0;
OOP_STATIC_FIELD(Pen, STATE_DOWN)  = 1;
OOP_FIELD(Pen, state) = 0;
OOP_FIELD(Pen, buffer) = "";
OOP_FIELD(Pen, x) = 0;
OOP_FIELD(Pen, y) = 0;

OOP_METHOD(Pen, down) = function ()
{
  this.state = OOP_STATIC_FIELD(Pen, STATE_DOWN);
  var bc = '_MV' +
           PROJECT_PREFIX.util.s64.encodeS4(this.x) +
           PROJECT_PREFIX.util.s64.encodeS4(this.y) +
           '_DN';
  this.buffer += bc;
};

OOP_METHOD(Pen, up) = function ()
{
  this.state = OOP_STATIC_FIELD(Pen, STATE_UP);

  var bc = '_UP';
  this.buffer += bc;
};

OOP_METHOD(Pen, moveTo) = function (x, y)
{
  if (this.state === OOP_STATIC_FIELD(Pen, STATE_DOWN)) {
    if (this.x !== x || this.y !== y) {
      var bc = '_MV' +
               PROJECT_PREFIX.util.s64.encodeS4(this.x) +
               PROJECT_PREFIX.util.s64.encodeS4(this.y) ;
      this.buffer += bc;
    }
  }
  this.x = x;
  this.y = y;
};

OOP_METHOD(Pen, setBrushColor) = function (r, g, b, a)
{
  var bc = '_BC' +
           PROJECT_PREFIX.util.s64.encodeU2(r * 4095) +
           PROJECT_PREFIX.util.s64.encodeU2(g * 4095) +
           PROJECT_PREFIX.util.s64.encodeU2(b * 4095) +
           PROJECT_PREFIX.util.s64.encodeU2(a * 4095) ;
  this.buffer += bc;
};

OOP_METHOD(Pen, setBrushSize) = function (size)
{
  var bc = '_BS' +  PROJECT_PREFIX.util.s64.encodeU2(size) ;
  this.buffer += bc;
};

OOP_METHOD(Pen, takeBuffer) = function ()
{
  var str = this.buffer;
  this.buffer = '';
  return str;
};

#endif /* _JDISP_GUI_PEN_JSH */
