#ifndef _JDISP_GUI_SPRITEPOOL_JSH
#define _JDISP_GUI_SPRITEPOOL_JSH

#define SPRITE_STATUS_READY 1
#define SPRITE_STATUS_BUSY  2

OOP_CLASS(SpritePool) = function(targetNode, numSprites)
{
  // TODO: check the value of numSprites.
  this.targetNode = PROJECT_PREFIX.domUtils.getNode(targetNode);
  this.numSprites = numSprites;
  this.sprites = [];
  this._initialize();
};

OOP_STATIC_FIELD(SpritePool, serial) = 0;
OOP_FIELD(SpritePool, idPrefix) = 'Sprite_';

OOP_METHOD(SpritePool, _initialize) = function ()
{
  var id;
  var h = '';
  var i;
  var list = new Array();

  for (i=0; i<this.numSprites; i++) {
    var sn = OOP_STATIC_FIELD(SpritePool, serial);
    OOP_STATIC_FIELD(SpritePool, serial)++;
    id = this.idPrefix + String(sn);
    list.push(id);
    h += '<span id="' + id + '">' +
         '</span>';
  }

  this.targetNode.innerHTML = h;

  for (i=0; i<list.length; i++) {
    id = list[i];
    var spriteNode = PROJECT_PREFIX.domUtils.getNode(id);
    var sprite = new OOP_CLASS(Sprite)(this, spriteNode);
    spriteNode.style.visibility = 'hidden';
    var rec = {sprite : sprite, status : SPRITE_STATUS_READY};
    this.sprites.push(rec);
  }
};

OOP_METHOD(SpritePool, borrowItem) = function ()
{
  var i;
  var sprite = null;
  for (i=0; i<this.sprites.length; i++) {
    var rec = this.sprites[i];
    if (rec.status === SPRITE_STATUS_READY) {
      rec.status = SPRITE_STATUS_BUSY;
      sprite = rec.sprite;
      break;
    }
  }
  return sprite;
};

OOP_METHOD(SpritePool, returnItem) = function (node)
{
  var i;
  for (i=0; i<this.sprites.length; i++) {
    var rec = this.sprites[i];
    if (node === rec.sprite) {
      if (rec.status === SPRITE_STATUS_BUSY) {
        rec.status = SPRITE_STATUS_READY;
      }
      break;
    }
  }
};

#endif /* _JDISP_GUI_SPRITEPOOL_JSH */
