#ifndef _JDISP_GUI_TOGGLESWITCH_JSH
#define _JDISP_GUI_TOGGLESWITCH_JSH

OOP_CLASS(ToggleSwitch) = function(targetNode)
{
  var n = PROJECT_PREFIX.domUtils.getNode(targetNode);
  var me = this;
  this.targetNode = n;
  this.items = [];
  this.index = 0;

  if (IS_NON_NULL_OBJECT(n)) {
    var f = function (ev) {
      me.next();
    };
    n.onclick = f;
  }
  this.update();
};

OOP_FIELD(ToggleSwitch, targetNode) = null;
OOP_FIELD(ToggleSwitch, items) = null;

OOP_METHOD(ToggleSwitch, add) = function (name, action)
{
  var item = {name:name, action:action};
  this.items.push(item);
  this.update();
};

OOP_METHOD(ToggleSwitch, next) = function ()
{
  var bound = this.items.length;
  if (bound > 0) {
    this.index = (this.index + 1) % bound;
    this.update();
  }
};

OOP_METHOD(ToggleSwitch, update) = function ()
{
  var item = null;
  var i = this.index;
  var bound = this.items.length;

  if (bound > 0) {
    do {
      if (i in this.items) {
        item = this.items[i];
        break;
      }
      i = (i + 1) % bound;
    } while (i !== this.index);
  }

  this.index = i;

  if (IS_NON_NULL_OBJECT(item)) {
    INVOKE_IF_SET(item.action, this);
    this.targetNode.innerHTML = PROJECT_PREFIX.global.escapeHtml(item.name);
  } else {
    this.targetNode.innerHTML = '----';
  }
};

#endif /* _JDISP_GUI_TOGGLESWITCH_JSH */
