#ifndef _OOP_JSH
#define _OOP_JSH

/*
 * Configurations
 */

#define OOP_SUPER_VAR _super


#define OOP_NAMESPACE_DEFINED(a) (typeof a === 'object')

#define OOP_DECLARE_NAMESPACE_ROOT(a) \
  if (!OOP_NAMESPACE_DEFINED(a)) { a = new Object(); }
#define OOP_DECLARE_NAMESPACE(a) \
  if (!OOP_NAMESPACE_DEFINED(a)) { a = new Object(); }

#define OOP_DECLARE_NAMESPACE1 OOP_DECLARE_NAMESPACE_ROOT
#define OOP_CONCAT1(a) a1
#define OOP_CONCAT2(a, ...) a.OOP_CONCAT1(__VA_ARGS__)
#define OOP_CONCAT3(a, ...) a.OOP_CONCAT2(__VA_ARGS__)
#define OOP_CONCAT4(a, ...) a.OOP_CONCAT3(__VA_ARGS__)
#define OOP_CONCAT5(a, ...) a.OOP_CONCAT4(__VA_ARGS__)
#define OOP_CONCAT6(a, ...) a.OOP_CONCAT5(__VA_ARGS__)
#define OOP_CONCAT7(a, ...) a.OOP_CONCAT6(__VA_ARGS__)
#define OOP_CONCAT8(a, ...) a.OOP_CONCAT7(__VA_ARGS__)
#define OOP_DECLARE_NAMESPACE2(a1, a2) \
  OOP_DECLARE_NAMESPACE1(a1) \
  OOP_DECLARE_NAMESPACE(a1.a2)
#define OOP_DECLARE_NAMESPACE3(a1, a2, a3) \
  OOP_DECLARE_NAMESPACE2(a1, a2) \
  OOP_DECLARE_NAMESPACE(a1.a2.a3)
#define OOP_DECLARE_NAMESPACE4(a1, a2, a3, a4) \
  OOP_DECLARE_NAMESPACE3(a1, a2, a3) \
  OOP_DECLARE_NAMESPACE(a1.a2.a3.a4)
#define OOP_DECLARE_NAMESPACE5(a1, a2, a3, a4, a5) \
  OOP_DECLARE_NAMESPACE4(a1, a2, a3, a4) \
  OOP_DECLARE_NAMESPACE(a1.a2.a3.a4.a5)
#define OOP_DECLARE_NAMESPACE6(a1, a2, a3, a4, a5, a6) \
  OOP_DECLARE_NAMESPACE5(a1, a2, a3, a4, a5) \
  OOP_DECLARE_NAMESPACE(a1.a2.a3.a4.a5.a6)
#define OOP_DECLARE_NAMESPACE7(a1, a2, a3, a4, a5, a6, a7) \
  OOP_DECLARE_NAMESPACE6(a1, a2, a3, a4, a5, a6) \
  OOP_DECLARE_NAMESPACE(a1.a2.a3.a4.a5.a6.a7)
#define OOP_DECLARE_NAMESPACE8(a1, a2, a3, a4, a5, a6, a7, a8) \
  OOP_DECLARE_NAMESPACE7(a1, a2, a3, a4, a5, a6, a7) \
  OOP_DECLARE_NAMESPACE(a1.a2.a3.a4.a5.a6.a7.a8)

#define OOP_CLASS(cls) OOP_NAMESPACE.cls
#define OOP_MEMBER(cls, name) OOP_CLASS(cls).prototype.name
#define OOP_PRIVATE_MEMBER(cls, name) OOP_MEMBER(cls, name)
#define OOP_METHOD(cls, name) OOP_MEMBER(cls, name)
#define OOP_PRIVATE_METHOD(cls, name) OOP_MEMBER(cls, name)
#define OOP_FIELD(cls, name)  OOP_MEMBER(cls, name)
#define OOP_FIELDS(cls, dict) (function (d) { \
  for (var k in d) OOP_CLASS(cls).prototype[k] = d[k]; \
}) (dict)
#define OOP_PRIVATE_FIELD(cls, name) OOP_MEMBER(cls, name)
#define OOP_STATIC(cls, name) OOP_CLASS(cls).name
#define OOP_STATIC_FIELD(cls, name) OOP_STATIC(cls, name)
#define OOP_STATIC_METHOD(cls, name) OOP_STATIC(cls, name)
#define OOP_SUPER this.OOP_SUPER_VAR
#define OOP_EXTENDS(cls, base) \
  OOP_CLASS(cls).prototype = new base(); \
  OOP_CLASS(cls).prototype.OOP_SUPER_VAR = base;

#endif /* _OOP_JSH */
