#ifndef _JDISP_LOGGING_BASICLOGGER_JS
#define _JDISP_LOGGING_BASICLOGGER_JS

OOP_CLASS(BasicLogger) = function(id, max, f)
{
  this.lines = new Array();
  if (id) {
    this.setTargetId(id);
  }
  if (max !== null) {
    this.maxLines = Number(max);
  } else {
    this.maxLines = 25;
  }
  if (f !== null) {
    this.setEnabled(f);
  }
};

OOP_FIELD(BasicLogger, maxLines) = 1024;
OOP_FIELD(BasicLogger, maxLineLength) = 4096;
OOP_FIELD(BasicLogger, digits) = 6;
OOP_FIELD(BasicLogger, lines) = null;
OOP_FIELD(BasicLogger, count) = 0;
OOP_FIELD(BasicLogger, targetId) = null;
OOP_FIELD(BasicLogger, targetNode) = null;
OOP_FIELD(BasicLogger, nodeFetched) = false;
OOP_FIELD(BasicLogger, enabled) = true;
OOP_METHOD(BasicLogger, setEnabled) = function (f)
{
  f = Boolean(f);
  this.enabled = f;
};

OOP_METHOD(BasicLogger, setMaxLines) = function (n)
{
  if (IS_NUMBER(n) && 0 <= n) {
    this.maxLines = n;
  }
};

OOP_METHOD(BasicLogger, setTargetId) = function (id)
{
  this.targetId = id;
  this.nodeFetched = false;
  this.update();
};

OOP_METHOD(BasicLogger, append) = function (msg0)
{
  if (!this.enabled) return;
  var msg = String(msg0);
  msg = msg.slice(0, this.maxLineLength);
  this.count++;
  var s = "[" + PROJECT_PREFIX.global.zeroPrefix(this.count, this.digits) + "] " +
          PROJECT_PREFIX.global.escapeHtml(msg) ;
  var lines = this.lines;
  var max = this.maxLines;
  lines.push(s);
  while (lines.length > max) {
    lines.shift();
  }
  this.update();
};

OOP_METHOD(BasicLogger, update) = function ()
{
  if (!this.enabled) return;
  if (!this.nodeFetched) {
    this.nodeFetched = true;
    var n = PROJECT_PREFIX.domUtils.getNode(this.targetId);
    this.targetNode = n;
  }
  var html = this.lines.join("<br />\r\n");
  PROJECT_PREFIX.domUtils.setHtml(this.targetNode, html);
};

#endif /* _JDISP_LOGGING_BASICLOGGER_JS */
