#ifndef _JDISP_TEXT_LISTPRINTER_JSH
#define _JDISP_TEXT_LISTPRINTER_JSH

OOP_CLASS(ListPrinter) = function(left, separator, right, filter) {
  IMPORT_ARGUMENT(left);
  IMPORT_ARGUMENT(separator);
  IMPORT_ARGUMENT(right);
  IMPORT_ARGUMENT(filter);
  this.data = this.left;
  this.sep = '';
};

OOP_FIELD(ListPrinter, data) = '';
OOP_FIELD(ListPrinter, left) = '(';
OOP_FIELD(ListPrinter, sep) = '';
OOP_FIELD(ListPrinter, separator) = ',';
OOP_FIELD(ListPrinter, right) = ')';

OOP_METHOD(ListPrinter, filter) = function (s)
{
  return String(s);
};

OOP_METHOD(ListPrinter, append) = function (obj)
{
  var i;
  if (obj instanceof Array) {
    for (i in obj) {
      this.data += this.sep + this.filter(obj[i]);
      this.sep = this.separator;
    }
  } else {
    this.data += this.sep + this.filter(obj);
    this.sep = this.separator;
  }
};

OOP_METHOD(ListPrinter, toString) = function ()
{
  return this.data + this.right;
};

#endif /* _JDISP_TEXT_LISTPRINTER_JSH */
