#ifndef _JDISP_UTIL_MULTIVALUEMAP_JSH
#define _JDISP_UTIL_MULTIVALUEMAP_JSH

OOP_CLASS(MultiValueMap) = function()
{
  this.data = new Object();
};

#if 0
OOP_STATIC_METHOD(MultiValueMap, fromDict) = function(dict)
{
  // TODO: implement MultiValueMap#fromDict()

  var a = new OOP_CLASS(MultiValueMap)();
  a.data = dict;
  return a;
};
#endif

OOP_STATIC_METHOD(MultiValueMap, fromQueryString) = function(str)
{
  if (!IS_STRING(str)) return undefined;

  var mm = new OOP_CLASS(MultiValueMap)();
  var idx;
  var pairs = str.split('&');
  for (j in pairs) {
    var pair = pairs[j];
    // Note that IE6 comes here with pair == '' in the case where str==''
    var name, value;
    idx = pair.indexOf('=');
    if (idx === -1) {
      name = pair;
      value = null;
    } else {
      name = pair.substring(0, idx);
      idx = idx + 1;
      value = pair.substring(idx);
      name = PROJECT_PREFIX.global.decodeURIComponent(name);
      value = PROJECT_PREFIX.global.decodeURIComponent(value);
    }
    if (!IS_NULL(name) && name !== '') {
      mm.put(name, value);
    }
  }

  return mm;
};

OOP_FIELD(MultiValueMap, data) = new Object();
OOP_METHOD(MultiValueMap, put) = function(key, value)
{
  var a = null;
  if (key in this.data) {
    a = this.data[key];
  } else {
    a = new Array();
    this.data[key] = a;
  }
  a.push(value);
};

OOP_METHOD(MultiValueMap, getValues) = function(key)
{
  if (key in this.data) {
    return this.data[key];
  } else {
    return undefined;
  }
};

OOP_METHOD(MultiValueMap, get) = function(key)
{
  if (key in this.data) {
    return this.data[key][0];
  } else {
    return undefined;
  }
};

OOP_METHOD(MultiValueMap, walk) = function(handler)
{
  for (var key in this.data) {
    var a = this.data[key];
    for (var i in a) {
      var value = a[i];
      INVOKE_IF_SET(handler, key, value);
    }
  }
};

OOP_METHOD(MultiValueMap, toString) = function()
{
  return (PROJECT_PREFIX.global.dumpVar(this.data));
};

OOP_METHOD(MultiValueMap, toQueryString) = function()
{
  var lp = new PROJECT_PREFIX.text.ListPrinter('', '&', '');
  this.walk(function (k, v) {
    if (IS_NULL(v)) {
      lp.append(this.encodeURIComponent(k));
    } else {
      lp.append (
        this.encodeURIComponent(k) +
        '=' + this.encodeURIComponent(v));
    }
  });

  return lp.toString();
};


#endif /* _JDISP_UTIL_MULTIVALUEMAP_JSH */
